#include <stdio.h>

static inline unsigned int multGF( unsigned int a, unsigned int b, int x_to_w, unsigned int* gflog, unsigned int* gfilog){
	int sum_log;

	if (a==0 || b ==0) return 0;
	sum_log = gflog[a] + gflog[b];
	if (sum_log >= x_to_w-1 ) sum_log -= x_to_w - 1 ;
	return gfilog[sum_log] ;
}


int gfd_gfd_signature(unsigned int* S, unsigned int* X, int n,int w, int m,
						unsigned int* gflog, unsigned int* gfilog){

	unsigned int s[m] ; 
	unsigned int x_to_w ;
	int i,j,mask,index;


	x_to_w = 1 << w ;
	mask = x_to_w - 1 ;

	for (i=1;i<m+1;i++){
		s[i-1] = (X[0]&mask) ;
		index = 0;
		for (j=1;j<n;j++){
			index += i ;
			if (index >= mask) index -= mask; /* on refait le modulo 2^w -1 a la main */
			s[i-1] ^= multGF ( gfilog [ index ] , (X[j]&mask) , x_to_w, gflog, gfilog) ;
		}
	}

	S[0] = s[0];
	for (i=2;i<m+1;i++)
		S[0] = (S[0] << w) | s[i-1];
	S[1] = n;	

	return 0;
}
