#include <stdio.h>

static inline unsigned int circular_shift( unsigned int value, 
		int bits, int base )
{
	unsigned int b;
	unsigned int mask;

	mask  = (1 << base) - 1;
	value = value & mask;
	if( bits > base ) bits = bits % base ; 
	b = (value >> (base - bits)) & mask;
	return b | ((value << bits) & mask);
}

int xor_bs1_signature(unsigned int* S, unsigned int* X, int n,int w, int m){

unsigned int s[m] ; 
unsigned int mask ;
unsigned int x_to_w ;
int i,j,k;

x_to_w = 1 << w ;
mask   = x_to_w - 1 ;


/*
s[0] = X[0] & mask ;
for (j=1;j<n;j++){
	s[0] = (s[0] ^ X[j]) & mask ;
}
*/
	
/*for (i=1;i<m;i++){*/
for (i=1;i<m+1;i++){
	k =0;
	s[i-1] = X[0] & mask ;
	for (j=1;j<n;j++){
		k += i;
		s[i-1] = (s[i-1] ^ circular_shift(X[j],k,w)) ;
	}
}

S[0] = s[0];
/*for (i=1;i<m;i++)*/
for (i=2;i<m+1;i++)
    S[0] = (S[0] << w) | s[i-1];
S[1] = n;	

return 0;
}
