#include <stdio.h>
#include <stdlib.h> /* to get the random number library */

int georgia_genX_random(int wg, int nx, int mx, unsigned int** X, unsigned int** s, int* nbx){

int i, j, k1, k2, lx, nb, nbij;
int seed ;

seed=1;
srand(seed);	

if(nx==mx)
	(*nbx) = wg + 3*wg*(wg-1) ;
else
	(*nbx) = wg + 5*wg*(wg-1) ;

lx     = nx*mx ;
	
(*X) = (unsigned int *)malloc((*nbx)*lx*sizeof(unsigned int)) ;
if ((*X)==NULL){ printf("error of memory allocation\n"); exit(0); }
(*s) = (unsigned int *)malloc((*nbx)*2*sizeof(unsigned int)) ;
if ((*s)==NULL){ printf("error of memory allocation\n"); exit(0); }

nb=0;
nbij=0;

/* n*m:alpha_i */
for (i=0;i<wg;i++){
	for (j=0;j<lx;j++){
		while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
		(*X)[nbij]++ ;
		//(*X)[nbij] = i+1;
		nbij++ ;
	}
	nb++ ;
}	

/* m:(1:alpha_i, (n-1):alpha_j ) */
for (i=0;i<wg;i++){
	for (j=0;j<wg;j++){
		if (!(i==j)) {
			for (k1=0;k1<mx;k1++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = i+1;
				nbij++ ;
				for (k2=0;k2<nx-1;k2++){
					while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
					(*X)[nbij]++ ;
					//(*X)[nbij] = j+1;
					nbij++ ;
				}
			}
			nb++ ;
		}
	}
}

/* 1:alpha_i , (m-1):(1:alpha_i, (n-1):alpha_j ),  (1:alpha_i, (n-2):alpha_j )*/
for (i=0;i<wg;i++){
	for (j=0;j<wg;j++){
		if (!(i==j)) {
			while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
			(*X)[nbij]++ ;
			//(*X)[nbij] = i+1;
			nbij++ ;
			for (k1=0;k1<mx-1;k1++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = i+1;
				nbij++ ;
				for (k2=0;k2<nx-1;k2++){
					while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
					(*X)[nbij]++ ;
					//(*X)[nbij] = j+1;
					nbij++ ;
				}
			}
			while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
			(*X)[nbij]++ ;
			//(*X)[nbij] = i+1;
			nbij++ ;
			for (k2=0;k2<nx-2;k2++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = j+1;
				nbij++ ;
			}
			nb++ ;
		}
	}
}

/* 1:alpha_i , (m-1):(1:alpha_i, (n-1):alpha_j ),  (1:alpha_i, (n-2):alpha_j )*/
for (i=0;i<wg;i++){
	for (j=0;j<wg;j++){
		if (!(i==j)) {
			for (k1=0;k1<mx*nx/2;k1++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = i+1;
				nbij++ ;
			}
			k2 = mx*nx/2 ; if (k2*2 < mx*nx) k2++ ;
			for (k1=0;k1<k2;k1++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = j+1;
				nbij++ ;
			}
			nb++ ;
		}
	}
}

if (nx==mx) return(0) ;

 i = nx ; 
nx = mx;
mx =  i;
/* m:(1:alpha_i, (n-1):alpha_j ) */
for (i=0;i<wg;i++){
	for (j=0;j<wg;j++){
		if (!(i==j)) {
			for (k1=0;k1<mx;k1++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = i+1;
				nbij++ ;
				for (k2=0;k2<nx-1;k2++){
					while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
					(*X)[nbij]++ ;
					//(*X)[nbij] = j+1;
					nbij++ ;
				}
			}
			nb++ ;
		}
	}
}


/* 1:alpha_i , (m-1):(1:alpha_i, (n-1):alpha_j ),  (1:alpha_i, (n-2):alpha_j )*/
for (i=0;i<wg;i++){
	for (j=0;j<wg;j++){
		if (!(i==j)) {
			while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
			(*X)[nbij]++ ;
			//(*X)[nbij] = i+1;
			nbij++ ;
			for (k1=0;k1<mx-1;k1++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = i+1;
				nbij++ ;
				for (k2=0;k2<nx-1;k2++){
					while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
					(*X)[nbij]++ ;
					//(*X)[nbij] = j+1;
					nbij++ ;
				}
			}
			while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
			(*X)[nbij]++ ;
			//(*X)[nbij] = i+1;
			nbij++ ;
			for (k2=0;k2<nx-2;k2++){
				while (wg < ((*X)[nbij] = rand() / (RAND_MAX/wg)) );
				(*X)[nbij]++ ;
				//(*X)[nbij] = j+1;
				nbij++ ;
			}
			nb++ ;
		}
	}
}

if (!(nb==(*nbx))){ printf("mauvaise estimation du nb de vecteur: %d %d\n",nb,(*nbx));exit(0); }
if (!((*nbx)*lx==nbij)){ printf("mauvaise estimation de la taille des vecteur\n");exit(0); }


return 1;

}
